<?php
/**
 * Created for Schaffen IT.
 * User: Thiago Traczykowski
 */

namespace App\RestApi\Form\Controllers;


use App\RestApi\Form\Requests\FieldRequest;
use Freelabois\LaravelQuickstart\Traits\Crudable;
use Schaffen\Core\Form\Managers\FieldManager;
use Schaffen\Core\Form\Repositories\FieldRepository;

class FieldController
{
    use Crudable;

    public function __construct(
        FieldManager $manager,
        FieldRepository $repository
    )
    {
        $this->setup($manager, $repository);
    }

    public function index(FieldRequest $request)
    {
        $params = $request->all();
        $perPage = request()->get('perPage') ?? 45;
        $with = request()->get('with') ?? [];
        $sanitized = request()->except(['perPage', 'with']);
        return $this->resource::collection($this->repository
            ->setOrder(
                $params["orderBy"] ?? 'cam_codigo',
                isset($params["orderBy"])
                    ? 'asc'
                    : 'desc')
            ->list($sanitized, $with, $perPage));
    }

    public function store(FieldRequest $request)
    {
        $sanitized = $request->validated();
        return response()->json($this->manager->storeOrUpdate($sanitized), 201);
    }

    public function update(FieldRequest $request, $id)
    {
        $sanitized = $request->validated();
        return response()->json($this->manager->storeOrUpdate($sanitized, $id), 201);
    }


}
